// Minecraft Standalone Client
// Copyright (C) 2009-2010 Colin Bartolome
// Licensed under the GPL. See LICENSE.txt for details.

import java.awt.Dimension;
import java.lang.reflect.Field;
import java.net.URL;
import java.util.*;

import com.mojang.minecraft.*;

public class MainApplet extends MinecraftApplet
{
   private Main main;
   
   private l minecraft;
   
   private Map<String, String> parameters;
   
   private boolean tryAccess = true;;
   
   public MainApplet(Main main)
   {
      super();
      
      this.main = main;
      
      parameters = new HashMap<String, String>();
   }
   
   @Override
   public URL getCodeBase()
   {
      try
      {
         return new URL("http://minecraft.net:80/");
      }
      catch (Exception e)
      {
         System.err.println("Exception: " + e.toString());
         
         return null;
      }
   }
   
   @Override
   public URL getDocumentBase()
   {
      try
      {
         return new URL("http://minecraft.net:80/play.jsp");
      }
      catch (Exception e)
      {
         System.err.println("Exception: " + e.toString());
         
         return null;
      }
   }
   
   public void putParameter(String name, String value)
   {
      parameters.put(name, value);
   }
   
   @Override
   public String getParameter(String name)
   {
      String value = parameters.get(name);
      
      return value == null ? null : value;
   }
   
   @Override
   public void resize(Dimension size)
   {
      super.resize(size);

      if (tryAccess)
      {
         accessMinecraft();
         
         if (minecraft != null)
         {
            minecraft.b = size.width;
            minecraft.c = size.height;
         }
      }
   }
   
   public l getMinecraft()
   {
      if (minecraft == null)
         accessMinecraft();
      
      return minecraft;
   }
   
   private l accessMinecraft()
   {
      try
      {
         Field field = MinecraftApplet.class.getDeclaredField("minecraft");
         
         field.setAccessible(true);
         
         return minecraft = (l)field.get(this);
      }
      catch (Exception e)
      {
         System.err.println("Could not access private field; returning null: " + e);
         tryAccess = false;
         return null;
      }
   }
   
   @Override
   public void init()
   {
      super.init();
      
      new Compass(main, accessMinecraft());
   }
}
